(defun C:XY (/ PNT1 P1X P1Y STDY DY PTXT)
  
  (setq PNT1 (getpoint "\n Pick coordinate point: "))
  (setq P1X (car pnt1))
  (setq P1Y (cadr pnt1))
  (setq STDX (rtos P1X 2 3))
  (setq STDY (rtos P1Y 2 3))
  (setq PTXT (getpoint "\nPick text location: "))
  (command "leader" PNT1 PTXT "" (strcat "X=" STDX) (strcat "Y=" STDY) "")
  (princ)
)
(defun c:xyz ()
  (setq pnt1 (getpoint "\n pick coordinate point: "))
  (setq ptxt (getpoint "\n pick text location: " pnt1))
  (setq p1x (car pnt1))
  (setq p1y (cadr pnt1))
  (setq p1z (caddr pnt1))
  (setq stdx (rtos p1x 2 3))
  (setq stdy (rtos p1y 2 3))
  (setq stdz (rtos p1z 2 3))
  (command "leader" pnt1 ptxt "" (strcat "X=" stdx) (strcat "Y=" stdy) (strcat "Z=" stdz) "")
  (princ)
)
(defun c:lb (/ p x y ptcoord textloc)
  (while
    (setq p (getpoint "\nPick Point: "))
     (setq textloc (getpoint "\nPick Label Location: "))
     (setq x (rtos (car p)))
     (setq y (rtos (cadr p)))
     (setq ptcoord (strcat x ", " y))
     (command "_LEADER" p textloc "" ptcoord "")
  )
)
(defun c:lbz (/ p x y ptcoord textloc)
  (while
    (setq p (getpoint "\nPick Point: "))
     (setq textloc (getpoint "\nPick Label Location: "))
     (setq x (rtos (car p)))
     (setq y (rtos (cadr p)))
     (setq z (rtos (caddr p)))
     (setq ptcoord (strcat x ", " y ", " z))
     (command "_LEADER" p textloc "" ptcoord "")
  )
)















  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;; Title: Cordinate Table                ;;
  ;; Purpose: Numbering & create table     ;;
  ;; Written: Bijoy manoharan              ;;
  ;; Command: CN, CSN, RES, CRT            ;;
  ;; Date   : Sep-2011                     ;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;; sub function error 
 
(defun trap1 (errmsg)

           (setvar "attdia" ad)
	   (setvar "attreq" aq)
           (setq *error* temperr)
           (prompt "\n Enter Command CSN for Point Sub Numbering or CRT for Table")
(princ)
) ;defun

(defun trap2 (errmsg)

           (setvar "attdia" ad)
	   (setvar "attreq" aq)
           (setq *error* temperr)
           (prompt "\n Enter Command CN to Continue Point Numbering or CRT for Table")
(princ)
) ;defun

(defun trap3 (errmsg)

           (setq *error* temperr)
           (prompt "\nCoordinate Table Command Cancelled")
(princ)
) ;defun

;;-----------------------------------sub function to create block

(defun crb ( )
    (if (not (tblsearch "BLOCK" "CRBLK"))
        (progn
            (if (not (tblsearch "STYLE" "Gen-Text"))
                (entmake
                    (list
                        (cons 0 "STYLE")
                        (cons 100 "AcDbSymbolTableRecord")
                        (cons 100 "AcDbTextStyleTableRecord")
                        (cons 2 "Gen-Text")
                        (cons 70 0)
                        (cons 40 2.5)
                        (cons 3 "Arial.ttf")
                    )
                )
            )
            (entmake
                (list
                    (cons 0 "BLOCK")
                    (cons 8 "0")
                    (cons 370 0)
                    (cons 2 "CRBLK")
                    (cons 70 2)
                    (cons 4 "Block to Place Coordinate Points")
                    (list 10 0.0 0.0 0.0)
                )
            )
            (entmake
                (list
                    (cons 0 "CIRCLE")
                    (cons 8 "0")
                    (cons 370 0)
                    (list 10 0.0 0.0 0.0)
                    (cons 40 1.25)
                )
            )
            (entmake
                (list
                    (cons 0 "ATTDEF")
                    (cons 8 "0")
                    (cons 370 0)
                    (cons 7 "Gen-Text")
                    (list 10 3.0 2.5 0.0)
                    (list 11 3.0 2.5 0.0)
                    (cons 40 2.5)
                    (cons 1 "00")
                    (cons 3 "Coordinate Point")
                    (cons 2 "OO")
                    (cons 70 0)
                    (cons 72 0)
                    (cons 74 2)
                )
            )
            (entmake
                (list
                    (cons 0 "ENDBLK")
                    (cons 8 "0")
                )
            )
          
           ;;--- To set block units in metre 70-6
           
            (
                (lambda ( lst )
                    (regapp "ACAD")
                    (entmod
                        (append (subst (cons 70 6) (assoc 70 lst) lst)
                            (list
                               (list -3
                                   (list "ACAD"
                                       (cons 1000 "DesignCenter Data")
                                       (cons 1002 "{")
                                       (cons 1070 1)
                                       (cons 1070 1)
                                       (cons 1002 "}")
                                   )
                               )
                           )
                        )
                    )
                )
                (entget (cdr (assoc 330 (entget (tblobjname "BLOCK" "CRBLK")))))
            )
        )
    )
       ;;;--- to disable allow explod-----

       (vl-load-com)
       (setq BLOCKS
       (vla-get-Blocks
        (vla-get-activedocument
         (vlax-get-acad-object)
        )
       )
      BLK (vla-Item BLOCKS "CRBLK")
    )
   (vla-put-explodable (vla-Item BLOCKS "CRBLK") :vlax-false)

;;;--- end to disable allow explod-----

    (princ)
)


;;------------------------main functions-------

(defun c:CN(/ num num1 cv th pt ptlist name mh-text ad aq)

           (command "cmdecho"0)
           (setq clay (getvar "clayer"))
           (setq ad (getvar "attdia"))
           (setq aq (getvar "attreq"))
           (setq temperr *error*)
           (setq *error* trap1)
           (setvar "attdia" 0)
           (setvar "attreq" 1)
   
           
   ;;; variable input values
          (if (not df-hs) (setq df-hs 1000.0))    ; default horizontal scale
          
   ;;; input horizontal scale
          (setq hs (getreal (strcat "\nEnter scale 1:<" (rtos df-hs 2 0) ">: ")))
          (if (not hs) (setq hs df-hs) (setq df-hs hs))
          
      ;;; input text name  
        
           (if (not namef) (setq namef ""))
           (setq name (getstring (strcat "\nEnter prefix text <" namef ">: ")))
           (if (= name "") (setq name namef) (setq namef name))       
   
    ;;; input number
        
           (if (not nf-ns) (setq nf-ns 1))    ; default number
           (setq NUM (getreal (strcat "\nEnter point number : <" (rtos nf-ns 2 0) ">: ")))  
           (if (not num) (setq num nf-ns) (setq nf-ns num))
            
           (setq cv 1000.0)                       ; annotation multipiclation factor (eg. 1000 will diplay m as mm)
           (setq th (/ hs 1000.0))                ; scale factor to be applied to block
           
   ; to create new layer 

           (if (not (tblsearch "layer" "Coordinate Points")) (command "-LAYER" "N" "Coordinate Points" "C" "7" "Coordinate Points" "LT" "Continuous" "Coordinate Points""LW" "0.00" "Coordinate Points" ""))      
                    
   ;;; create mh numbers
   
    (setq ptlist nil) ; for while command
    
       (while     
         (progn 
    
           (setq PT (getpoint "\nPick point location: ")) ;;; input text location           
           
           (if (< num 10.0) (setq num1 (strcat "0" (rtos num 2 0))))
           (if (>= num 10.0) (setq num1 (rtos NUM 2 0)))
           
          (crb) ;create block
          
          (setq mh-text (strcat name num1)) ; combine text into one variable           
   
        (if (not (= pt nil))  (command "CLAYER" "Coordinate Points")) ;if
        (if (not (= pt nil))  (command "-insert" "CRBLK" pt th th "0" mh-text)) ;if
        (if (not (= pt nil))  (setvar "clayer" clay)) ;if
        (setq by (strcat (Chr 66)(Chr 73)(Chr 74)(Chr 79)(Chr 89)(Chr 183)(Chr 86)(Chr 183)(Chr 77)))
        (if (not (= pt nil))  (setq num (+ num 1))) ; for increment
        (if (not (= pt nil))  (setq suf (- num 1)))
        (if (not (= pt nil))  (setq nf-ns num))
        
           (setq ptlist (append ptlist (list pt))) ; to stop while command
           
          ) ;progn  
        ) ;while
        
(setvar "clayer" clay)        
(princ)
) ;defun


(defun c:CSN(/ numf snum sf-ss mh-text cv th pt ptlist ptx pty name ad aq)

           (command "cmdecho"0)
           (setq clay (getvar "clayer"))
           (setq ad (getvar "attdia"))
           (setq aq (getvar "attreq"))
           (setq temperr *error*)
           (setq *error* trap2)
           (setvar "attdia" 0)
           (setvar "attreq" 1)
           
       
            
   ;;; variable input values
          (if (not df-hs) (setq df-hs 1000.0))    ; default horizontal scale
          
   ;;; input horizontal scale
          (setq hs (getreal (strcat "\nEnter scale 1:<" (rtos df-hs 2 0) ">: ")))
          (if (not hs) (setq hs df-hs) (setq df-hs hs))
   
   ;;; input  name  
        
           (if (not namef) (setq namef ""))
           (setq name (getstring (strcat "\nEnter prefix text <" namef ">: ")))
           (if (= name "") (setq name namef) (setq namef name))

   ;;; input  number
        
           (if (not suf) (setq suf 1))    ; default number
           (setq NUMF (getreal (strcat "\nEnter point number : <" (rtos suf 2 0) ">: ")))  
            (if (not numf) (setq numf suf) (setq suf numf))

   ;;; input  sub number
        
           (if (not sf-ss) (setq sf-ss 1))    ; default number
           (setq SNUM (getreal (strcat "\nEnter point subnumber : <" (rtos sf-ss 2 0) ">: ")))  
            (if (not snum) (setq snum sf-ss) (setq sf-ss snum))
   
           (setq cv 1000.0)                       ; annotation multipiclation factor (eg. 1000 will diplay m as mm)
           (setq th (/ hs 1000.0))                ; scale factor to be applied to block

   ;;; set arial.ttf to default linestyle
           (if (not (tblsearch "style" "Gen-Text")) (command "-style" "Gen-Text" "Arial.ttf" 2.5 "1" 0 "n" "n"))
           
   ; to create new layer 

           (if (not (tblsearch "layer" "Coordinate Points"))
                    (command "-LAYER" "N" "Coordinate Points" "C" "7" "Coordinate Points" "LT" "Continuous" "Coordinate Points""LW" "0.00" "Coordinate Points" ""))      
                    
                    
   ;;; create NO numbers
   
    (setq ptlist nil) ; for while command
    
       (while     
         (progn 
    
           (setq PT (getpoint "\nPick Point location: ")) ;;; input text location
           
           (if (< numf 10.0) (setq numf1 (strcat "0" (rtos numf 2 0))))
           (if (>= numf 10.0) (setq numf1 (rtos numf 2 0)))

           (if (< snum 10.0) (setq snum1 (strcat "0" (rtos snum 2 0))))
           (if (>= snum 10.0) (setq snum1 (rtos snum 2 0)))

           (crb) ;create block
           
           (setq mh-text (strcat name numf1 "-" snum1)) ; combine text into one variable
           
           (if (not (= pt nil))(command "CLAYER" "Coordinate Points"))
           (if (not (= pt nil))(command "-insert" "CRBLK" pt th th "0" mh-text))
           (if (not (= pt nil))(setvar "clayer" clay))
           (if (not (= pt nil))(setq snum (+ snum 1))) ; for increment
           (if (not (= pt nil))(setq nf-ns (+ numf 1)))
           
           (setq ptlist (append ptlist (list pt))) ; to stop while command
            
          ) ;progn  
        ) ;while       
        
(princ)
) ;defun


(defun c:RES ()

   (setq namef "")
   (prompt "\nPrefix Text Variable Reseted")
   
(princ)
) ;defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;---------- sub function for Table----------

(defun CRTable ()        
        
	(setq LEN (length CORDS))
	(setq CORDS (acad_strlsort CORDS))			;;;sorts list into order
	(setq CNT 0)
	(if (= (getvar "tilemode") 1) (setvar "tilemode" 0))
	(command "pspace")
	
	(setq SP (getpoint "\nPick start point for table"))
	
        (setq ht 2.5) ;; text hieght
        
        (command "-style" "Gen-Text" "Arial.ttf" 2.5 "1" 0 "n" "n")
        (if (not (tblsearch "layer" "Coordinate Table")) 
        (command "-LAYER" "N" "Coordinate Table" "C" "7" "Coordinate Table" "LT" "Continuous" "Coordinate Table""LW" "0.00" "Coordinate Table" ""))
		
	(if (/= SP nil)						;;;checks for null input
	  (progn
	    (setq TXTX (car SP))				;;;gets x coord of text start point
	    (setq fx txtx)                                      ;;; set first x value
	   
	    (setq TXTY (cadr SP))				;;;gets y coord
	    (setq fy TXTY)
	    
	    (setq encw 25.00)  ; easting & northing Column width
            (setq nocw 20.00)  ; number Column width            
            
            (setq ten (/ encw 2))
            (setq tno (+ (/ nocw 2) ten))
	  
     ;; place easting & northing text
	    (entmake 
	      (list 
	        (cons 0 "text") 
	        (cons 1 "COORDINATES") 
	        (cons 7 "Gen-Text") 
	        (cons 8 "Coordinate Table")
	        (cons 10 (list (+ TXTX 2.5) (+ TXTY (/ ht 2) (* ht 2)))) 
	        (cons 11 (list (+ TXTX 2.5) (+ TXTY (/ ht 2) (* ht 2)))) 
	        (cons 40 3.0) 
	        (cons 50 0.0) 
	        (cons 72 4)
	      )
	    )
     
	    (entmake 
	      (list 
	        (cons 0 "text") 
	        (cons 1 "POINTS") 
	        (cons 7 "Gen-Text") 
	        (cons 8 "Coordinate Table")
	        (cons 10 (list (- TXTX tno) TXTY)) 
	        (cons 11 (list (- TXTX tno) TXTY)) 
	        (cons 40 ht) 
	        (cons 50 0.0) 
	        (cons 72 4)
	      )
	    )
	        
	    (entmake 
	      (list 
	        (cons 0 "text") 
	        (cons 1 "EASTING") 
	        (cons 7 "Gen-Text") 
	        (cons 8 "Coordinate Table")
	        (cons 10 (list TXTX TXTY)) 
	        (cons 11 (list TXTX TXTY)) 
	        (cons 40 ht) 
	        (cons 50 0.0) 
	        (cons 72 4)
	      )
	    )  
	        
	    (entmake 
	      (list 
	        (cons 0 "text") 
	        (cons 1 "NORTHING") 
	        (cons 7 "Gen-Text") 
	        (cons 8 "Coordinate Table")
	        (cons 10 (list (+ TXTX encw) TXTY)) 
	        (cons 11 (list (+ TXTX encw) TXTY)) 
	        (cons 40 ht) 
	        (cons 50 0.0) 
	        (cons 72 4)
	      )
	    )      
     
     ;; place easting & northing horizontal table lines
	    (entmake 
	      (list 
	        (cons 0 "line") 
	        (cons 8 "Coordinate Table") 
	        (cons 10 (list (- TXTX (+ ten nocw)) (+ TXTY ht)))
	        (cons 11 (list (+ TXTX ten encw) (+ TXTY ht)))
	      )
	    )
	     
	    (entmake 
	      (list 
	        (cons 0 "line") 
	        (cons 8 "Coordinate Table") 
	        (cons 10 (list (- TXTX (+ ten nocw)) (- TXTY ht)))
	        (cons 11 (list (+ TXTX ten encw) (- TXTY ht)))
	      )
	    )
	  
	  (repeat LEN
		(setq TXTY (- TXTY (* 2 HT)))			;;;set new y coord for text
		
		(setq SP (list TXTX TXTY))			;;;creates code start point
		(setq CORD (nth CNT CORDS))			;;;gets coord from list
		(setq COLEN (strlen CORD))			;
		(setq COM 1 GAP 1)	
				
		(while (/= COLEN COM)						;
			(setq COM1 (substr CORD COM 1))				;finds ',' in strings for
			(if (and (= COM1 ",") (= GAP 1)) (setq S1 COM GAP 2))	;spliting string
			(if (and (= COM1 ",") (= GAP 2)) (setq S2 COM))		;
			(setq COM (+ COM 1))				;
		) ;while
		
		(setq CODE (substr CORD 1 (- S1 1)))		;;;strips of code
		(setq SON (substr CORD (+ S1 1) (- S2 S1 1)))	;;;strips of north
		(setq SOE (substr CORD (+ S2 1) (- COLEN S2)))	;;;strips of east
		
	        (entmake 
	          (list 
	            (cons 0 "text") 
	            (cons 1 code) 
	            (cons 7 "Gen-Text") 
	            (cons 8 "Coordinate Table")
	            (cons 10 (list (- TXTX tno) TXTY))
	            (cons 11 (list (- TXTX tno) TXTY)) 
	            (cons 40 ht) 
	            (cons 50 0.0) (cons 72 4)
	          )
	        )
	        
	        (entmake 
	          (list 
	            (cons 0 "text") 
	            (cons 1 soe) 
	            (cons 7 "Gen-Text") 
	            (cons 8 "Coordinate Table")
	            (cons 10 (list TXTX TXTY)) 
	            (cons 11 (list TXTX TXTY)) 
	            (cons 40 ht) 
	            (cons 50 0.0) 
	            (cons 72 4)
	          )
	        )
	  	
	  	(entmake 
	  	  (list 
	  	    (cons 0 "text") 
	  	    (cons 1 son) (cons 7 "Gen-Text") 
	  	    (cons 8 "Coordinate Table")
	  	    (cons 10 (list (+ TXTX encw) TXTY)) 
	  	    (cons 11 (list (+ TXTX encw) TXTY)) 
	  	    (cons 40 ht) 
	  	    (cons 50 0.0) 
	  	    (cons 72 4)
	  	  )
	  	)
  	  
                (entmake 
                  (list 
                    (cons 0 "line") 
                    (cons 8 "Coordinate Table") 
                    (cons 10 (list (- TXTX (+ ten nocw)) (- TXTY ht)))
                    (cons 11 (list (+ TXTX ten encw) (- TXTY ht)))
                  )
                ) ;; horizontal lines
		
		(setq hl (entlast)) ; set hl as last horizontal line		
	
		(setq CNT (+ CNT 1))
		
	    ) ;repeat
	    
                (setq ly (caddr (assoc 10 (entget hl)))) ;set last y value
                
      ;; place easting & northing vertical table lines
               (entmake 
                  (list 
                    (cons 0 "line") 
                    (cons 8 "Coordinate Table") 
                    (cons 10 (list (- fx ten) (+ fy ht))) 
                    (cons 11 (list (- fx ten) ly))
                  )
               )
               
               (entmake 
                  (list 
                    (cons 0 "line") 
                    (cons 8 "Coordinate Table") 
                    (cons 10 (list (+ fx ten) (+ fy ht))) 
                    (cons 11 (list (+ fx ten) ly))
                  )
               )
	       
	       (entmake
	          (list
	            (cons 0 "LWPOLYLINE")
	            (cons 100 "AcDbEntity")
	            (cons 100 "AcDbPolyline")
	            (cons 8 "Coordinate Table")
	            (cons 90 4)
	            (cons 70 1)
	            (cons 10 (list (- fx (+ ten nocw)) (+ fy (* ht 4))))
	            (cons 10 (list (+ fx (+ ten encw)) (+ fy (* ht 4))))
	            (cons 10 (list (+ fx (+ ten encw)) ly))
	            (cons 10 (list (- fx (+ ten nocw)) ly))
	          )
               ) ; inner rectangle
	
	       (entmake
	          (list
	            (cons 0 "LWPOLYLINE")
	            (cons 100 "AcDbEntity")
	            (cons 100 "AcDbPolyline")
	            (cons 8 "Coordinate Table")
	            (cons 90 4)
	            (cons 70 1)
	            (cons 10 (list (- fx (+ ten nocw 1)) (+ fy (* ht 4) 1)))
	            (cons 10 (list (+ fx (+ ten encw 1)) (+ fy (* ht 4) 1)))
	            (cons 10 (list (+ fx (+ ten encw 1)) (- ly 1)))
	            (cons 10 (list (- fx (+ ten nocw 1)) (- ly 1)))
	          )
               ) ; outer rectangle	
	
	 (command "erase" hl "")
	
	  ) ; progn
	) ;if 
	(command "redraw")
	(princ)
	
) ; defun


;;-------------Main function to make List of points-----

(defun c:CRT (/ txtx txty len cord cords cnt sp ht code son soe sox soy so1 encw nocw ten tno lat hl ly fx fy)

	(setvar "cmdecho" 0)
	
	(setq temperr *error*)
        (setq *error* trap3)
        
	(setq CORDS nil LEN nil CNT 0)	;;resets coord list to nil
	(princ (strcat "\n "))
	
	(initget 1 "All Select")	 
	(setq sel (strcase (getkword "\Select individual coordinate points or Select All (S or A): ")))
	(if (= sel "SELECT") (setq SS (ssget '((2 . "crblk")))) (setq SS (ssget "X" '((2 . "crblk")))))
	  
	(command "UCS" "WORLD")
	
	(while (/= SS nil)					;;;checks for nil selection
	  (setq LEN (sslength SS))
	    (repeat LEN
		(setq SO0 (ssname SS CNT))
		(setq CORD (cdr (assoc '10 (entget SO0))))	;;;gets coords of point
		(setq SOX (rtos (car CORD) 2 3))		;;;strips off X coord
		(setq SOY (rtos (cadr CORD) 2 3))		;;;strips off Y coord
		(setq SO1 (entnext SO0))			;;;gets attribute entity
		(setq CODE (cdr (assoc '1 (entget SO1))))	;;;strips off point code from attribute
		(setq CORD (strcat CODE "," SOY "," SOX))	;;;creates string of code,y,x
		(setq CORDL (list CORD))			;;;converts into list
		(if (= CORDS nil) (setq CORDS CORDL) (setq CORDS (append CORDL CORDS)))	;;;starts new list or adds to old
		(setq CNT (+ CNT 1))
	    )
	  (setq SS nil)						;;;finishes loop
	) ;while
	
	(command "UCS" "P")
	
	(if (/= (length CORDS) 0) (CRTable))
	
	(setq *error* temperr)
	(prompt "\n Coordinate Table is Placed\n © Bijoy Manoharan 2011 www.cadlispandtips.com")
	(princ)
) ;defun


;;------------- end Main function --------------------

(alert "-------------------------- Coordinates with Table ---------------------------

\n Commands                                           
\n    Command   CN   ( For Increment Coordinate Point Number )
\n    Command   CSN  ( For Increment Coordinate Point Sub Number )
\n    Command   RES  ( To Reset Prefix Text Variable )
\n    Command   CRT  ( To Place Coordinate Table )
\n Steps
\n 1. Enter appropriate Scale (in A1) to be drawn
\n 2. Enter Prefix Text
\n 3. Enter Starting Number
\n 4. Pick Text Location
\n 5. After Placing Coordinate Points run Command CRT to place table   
\n 6. Type A to select all coordinate points
\n 7. Type S to select individual coordinate points
\n 8. Pick a point to place Coordinate Table.

\nBijoy manoharan\nSep 2011\nwww.cadlispandtips.com")



















(defun c:QM()
(princ "\n Type QM  to Start Subscribe on youtube ")
;(command "osnap" "none" )  
(command "osnap" "int,endpoint" )  

 ;;;Layears;;        
            (command "layer" "m" "COORDINATES LISP" "" "" "" "")
(command "layer" "set" "COORDINATES LISP" "") 
	    
(setq p(getpoint "\n Select First Point :")
      pp(getpoint "\n Select Second Point :")      
      u(getint "\n Enter start Point number:")
      tab(getpoint "\n Click Upper Left Corner of Table:")            
      u1 (+ 1 u)
      x(car p)
      y(cadr p)
      z(caddr p)
      x1(car pp)
      y1(cadr pp)
      z1(caddr pp)
      text(strcat "(" (rtos x 2 4) "," (rtos y 2 4)")")
      text1(strcat "(" (rtos x1 2 4) "," (rtos y1 2 4) ")") 
      p1(mapcar '+ p (list 0.25 0.45))
      p2(mapcar '+ pp (list 0.25 0.45))
      p10(mapcar '+ p (list 0.25 -0.45))      
      p11(mapcar '+ pp (list 0.25 -0.45))      
      tab1(mapcar '+ tab (list 45 0 ))
      tab2(mapcar '+ tab (list 90 0 ))
      tab3(mapcar '+ tab (list 135 0 ))
      tab4(mapcar '+ tab (list 180 0 ))
      tab5(mapcar '+ tab (list 0 -12))
      tab6(mapcar '+ tab1 (list 0 -12 ))
      tab7(mapcar '+ tab2 (list 0 -12 ))
      tab8(mapcar '+ tab3 (list 0 -12 ))
      tab9(mapcar '+ tab4 (list 0 -12 ))
      tab10(mapcar '+ tab5 (list 0 -12))
      tab11(mapcar '+ tab6 (list 0 -12))
      tab12(mapcar '+ tab7 (list 0 -12))
      tab13(mapcar '+ tab8 (list 0 -12))
      tab14(mapcar '+ tab9 (list 0 -12))
      tab15(mapcar '+ tab10 (list 0 -12))
      tab16(mapcar '+ tab11 (list 0 -12))
      tab17(mapcar '+ tab12 (list 0 -12))
      tab18(mapcar '+ tab13 (list 0 -12))
      tab19(mapcar '+ tab14 (list 0 -12))
      POINa(mapcar '+ tab (list 0.0 10))
      POIN(mapcar '+ tab (list 10.65 -8.7))
      POIN1(mapcar '+ tab1 (list 10.45 -8.7))
      POIN2(mapcar '+ tab2 (list 10.45 -8.7))
      POIN3(mapcar '+ tab3 (list 10.90 -8.7))
      POIN4(mapcar '+ tab5 (list 23 -8.7))
      POIN5(mapcar '+ tab6 (list 23 -8.7))
      POIN6(mapcar '+ tab7 (list 23 -8.7))
      POIN7(mapcar '+ tab8 (list 23 -8.7))
      POIN8(mapcar '+ poin4 (list 0 -10))
      POIN9(mapcar '+ poin5 (list 0 -10))
      POIN10(mapcar '+ poin6 (list 0 -10))
      POIN11(mapcar '+ poin7 (list 0 -10))
      uu(strcat "" (itoa u) )
      uu1(strcat "" (itoa u1) )
)
(command "osnap" "none" )  
         (command "Style" n "" "" "" "" "" "" "")
(command "style" "romans" "romans" "3.25" "1" "0" "n" "n" "n" "")
(command "3DPOLY" p pp "")
(command "line" tab tab4 "")
(command "line" tab5 tab9 "")
(command "line" tab10 tab14 "")
(command "line" tab15 tab19 "")
(command "line" tab tab15 "")
(command "line" tab1 tab16 "")
(command "line" tab2 tab17 "")
(command "line" tab3 tab18 "")
(command "line" tab4 tab19 "")
(command "circle" p "0.50" )
(command "change" "l" "" "p" "c" "4" "")
(command "circle" pp "0.50" )
(command "change" "l" "" "p" "c" "4" "")
;(command "text" p1 "0"  text "")
;(command "text" p2 "0"  text1 "")
;(command "text" p4 "0"  text2 "")
(command "text" p10 "0"uu "")
(command "text" p11 "0"uu1 "")
(command "text" poina "0"  "Subscribe Surveying Engineering Design Information" "")  
(command "text" poin "0"  "POINT#" "")  
(command "text" poin1 "0"  "EASTING" "")
(command "text" poin2 "0"  "NORTHING" "")
(command "text" poin3 "0"  "ELEVATION" "")
(command "text" poin4 "0" uu "")
(command "text" poin8 "0" uu1 "")
(command "text" "j" "mc" poin5 "0" (rtos x 2 4) "")
(command "text" "j" "mc" poin6 "0" (rtos y 2 4) "")
(command "text" "j" "mc" poin7 "0" (rtos z 2 4) "")
(command "text" "j" "mc" poin9 "0" (rtos x1 2 4) "")
(command "text" "j" "mc" poin10 "0" (rtos y1 2 4) "")
(command "text" "j" "mc" poin11 "0" (rtos z1 2 4) "")
(command "osnap" "int,endpoint" )    
  (command "osnap" "int,endpoint" )
  (setq  ppp(getpoint "\n Select Next Point :")       )
  (while ( /= ppp nil )
    (progn
      (setq
        u1 (+ 1 u1)
        x1(car ppp)
        y1(cadr ppp)
        z1(caddr pp)
        text1(strcat "(" (rtos x1 2 4) "," (rtos y1 2 4) ")") 
        p2(mapcar '+ ppp (list 0.25 0.45))
        p11(mapcar '+ ppp (list 0.25 -0.45))      
        uu1(strcat "" (itoa u1) )
        tab15(mapcar '+ tab15 (list 0 -12))
        tab16(mapcar '+ tab16 (list 0 -12))
        tab17(mapcar '+ tab17 (list 0 -12))
        tab18(mapcar '+ tab18 (list 0 -12))
        tab19(mapcar '+ tab19 (list 0 -12))
        POIN8(mapcar '+ poin8 (list 0 -12))
        POIN9(mapcar '+ poin9 (list 0 -12))
        POIN10(mapcar '+ poin10 (list 0 -12))
        POIN11(mapcar '+ poin11 (list 0 -12))

      );setq
(command "osnap" "none" )  
    (command "3DPOLY" pp ppp "")
     (command "circle" ppp "0.50" )
     (command "change" "l" "" "p" "c" "4" "")
     ;(command "text" p2 "0"  text1 "")
     
     (command "text" p11 "0"uu1 "")
(command "text" poin8 "0"uu1 "")
(command "text" "j" "mc" poin9 "0" (rtos x1 2 4) "")
(command "text" "j" "mc" poin10 "0" (rtos y1 2 4) "")
(command "text" "j" "mc" poin11 "0" (rtos z1 2 4) "")
(command "line" tab15 tab19 "")


     (setq pp ppp
           ;u1 (+ 1 u1)
     );setq
  (command "osnap" "int,endpoint" )
     (setq  ppp(getpoint "\n Select Next Point :")  )
     );progn
  )   ;while
  (command "osnap" "none" )
(command "line" tab tab15 "")
(command "line" tab1 tab16 "")
(command "line" tab2 tab17 "")
(command "line" tab3 tab18 "")
(command "line" tab4 tab19 "")


(command "osnap" "int,endpoint" )  
  );end

**************************************************************************************************
(prompt "\nwritten by Mr. Qaisar Malik")
(prompt "\nEnter QM to start")
(prompt "\nSUBSCRIBE www.youtube.com/surveyingengineeringdesigninformation")
*****************************************************************************************************


