(defun C:chamdist ( / sel1 sel2 ent1 ent2 p11 p12 p21 p22 dlist ang a1 a2
chamdi chamval p1neu p2neu)
(setq sel1 (entsel "\nFirst line: ")
ent1 (entget (car sel1)))
(if (not (= (cdr (assoc 0 ent1)) "LINE")) (progn (princ "\n... is no
line") (exit)))
(setq sel2 (entsel "\nSecond line: ")
ent2 (entget (car sel2)))
(if (not (= (cdr (assoc 0 ent2)) "LINE")) (progn (princ "\n... is no
line") (exit)))
(setq p11 (cdr (assoc 10 ent1))
p12 (cdr (assoc 11 ent1))
p21 (cdr (assoc 10 ent2))
p22 (cdr (assoc 11 ent2))
dlist (list (cons (distance p11 p21) 1) (cons (distance p11 p22) 2)
(cons (distance p12 p21) 3) (cons (distance p12 p22)
4)))
(setq dlist (vl-sort dlist (function (lambda (x1 x2) (< (car x1) (car
x2))))))
(cond ((= (cdar dlist) 1)
(setq ang (- (setq a1 (angle p11 p12)) (setq a2 (angle p21 p22)))))
((= (cdar dlist) 2)
(setq ang (- (setq a1 (angle p11 p12)) (setq a2 (angle p22 p21)))))
((= (cdar dlist) 3)
(setq ang (- (setq a1 (angle p12 p11)) (setq a2 (angle p21 p22)))))
(T
(setq ang (- (setq a1 (angle p12 p11)) (setq a2 (angle p22
p21))))))
(if (not (equal (sin (/ ang 2.0)) 0.0 0.0001))
(progn
(setq chamdi (getreal "\nLength of result line: ")
chamval (abs (/ chamdi (* 2.0 (sin (/ ang 2.0)))))
p1neu (polar (inters p11 p12 p21 p22 nil) a1 chamval)
p2neu (polar (inters p11 p12 p21 p22 nil) a2 chamval))
(cond ((= (cdar dlist) 1)
(setq ent1 (subst (cons 10 p1neu) (assoc 10 ent1) ent1)
ent2 (subst (cons 10 p2neu) (assoc 10 ent2) ent2)))
((= (cdar dlist) 2)
(setq ent1 (subst (cons 10 p1neu) (assoc 10 ent1) ent1)
ent2 (subst (cons 11 p2neu) (assoc 11 ent2) ent2)))
((= (cdar dlist) 3)
(setq ent1 (subst (cons 11 p1neu) (assoc 11 ent1) ent1)
ent2 (subst (cons 10 p2neu) (assoc 10 ent2) ent2)))
(T
(setq ent1 (subst (cons 11 p1neu) (assoc 11 ent1) ent1)
ent2 (subst (cons 11 p2neu) (assoc 11 ent2) ent2))))
(entmod ent1)
(entmod ent2)
(setq ent1 (subst (cons 10 p1neu) (assoc 10 ent1) ent1)
ent1 (subst (cons 11 p2neu) (assoc 11 ent1) ent1))
(entmake ent1)
)
(princ "\nLines are parallel")
)
(princ)
)
