;Quit all drawings without saving (CAD Studio - www.cadforum.cz)
(vl-load-com)
(defun C:QA ( / dwg)
 (vlax-for dwg (vla-get-Documents (vlax-get-acad-object))
  (if (= (vla-get-active dwg) :vlax-false)(vla-close dwg :vlax-false))
 )
 (command "._close" "_y")
)
Save


(defun c:QAB (/)
 ;; Close all but active drawing (with option to save inactive)
 ;; Express Tool subroutine "ACET-UI-Message" required
 ;; Alan J. Thompson, 06.09.10
 ((lambda (save)
    (vlax-for x (vla-get-documents
                  (cond (*Acad*)
                        ((setq *Acad* (vlax-get-acad-object)))
                  )
                )
      (or (eq :vlax-true (vla-get-active x))
          (vl-catch-all-apply (function vla-close) (list x save))
      )
    )
  )
   (if (eq 6 (acet-ui-message "Save drawings before closing?" "Close All But Active Drawing" 52))
     :vlax-true
     :vlax-false
   )
 )
 (princ)
)